> ## Documentation Index
> Fetch the complete documentation index at: https://developer.jtl-software.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Creates a new bill of materials operation for a bill of materials, including its items.

> Creates a new bill of materials operation for a bill of materials, including its items.



## OpenAPI

````yaml /openapi/2.0.json post /v2/bills-of-materials/{billOfMaterialsId}/bill-of-materials-operations
openapi: 3.0.0
info:
  title: JTL-WAWI API (Cloud)
  description: "JTL-Wawi-Version: 2.1.0\r\n# Introduction\r\n\r\nWelcome to the JTL-WAWI technical API documentation. This guide is here to help developers understand how our REST API works and how it can be integrated into your existing systems. We'll delve into the details of authentication and data manipulation processes, providing clear examples along the way. Whether you're a developer or an IT professional, this documentation aims to give you a practical understanding, laying the groundwork for effectively using the JTL-WAWI API to enhance your processes.\r\n\r\n# Authentication\r\n\r\nYou register your application with the API by sending a POST request with the required information and corresponding keys. You can find the exact request details at https://developer.jtl-software.com/products/erp/swagger/appregistration. This information has to include the following:\r\n\r\n* AppId\r\n* DisplayName\r\n* Description\r\n* Version\r\n* ProviderName\r\n* ProviderWebsite\r\n* MandatoryApiScopes\r\n\r\nThis data is crucial for identifying and registering your application with the API. The API uses it to generate a temporary authentication ID that allows your application to access the necessary resources. After successful validation of this information, you will receive the API key required for future authentication and API requests.\r\n\r\nBefore you can begin the registration process, you must open JTL-Wawi (new interface) and start the registration process under 'Admin->App registration'. Only at this point are you authorised to send the first API call. This step in JTL-Wawi ensures that your application is properly registered and has permission to use the API.\r\n\r\nThe API will send you an authentication ID in the form of a token. Once you have received this token and successfully completed the registration in JTL-Wawi, you will send another request to the API by including this authentication ID in the URL path.\r\n\r\nAfter successful validation of this second request by the API and confirmation of the correct information, you will be provided with the actual API key. It is important to note that this API key will not be displayed again!\r\n\r\nThis API key will be used in the future to authenticate requests to the API. It is of utmost importance that you securely store the API key upon receipt, as it cannot be retrieved from any other location in the system."
  contact:
    name: JTL-Software-GmbH
    url: https://developer.jtl-software.com/
    email: partner@jtl-software.com
  version: '2.0'
  x-application-version: 2.1.0.0
servers:
  - url: https://api.jtl-cloud.com/erp
    description: Production Environment Cloud API Gateway
security: []
tags:
  - name: Worker
    description: >-
      <p data-section-id='tag/Worker' class='beta_summary'></p>Returns the
      Available Syncs of the Worker
  - name: WMS
    description: >-
      <p data-section-id='tag/WMS' class='stable_summary'></p>Query all pick
      lists for a specific wms warehouse that are not completed.
  - name: Wawi App
    description: >-
      <p data-section-id='tag/Wawi App' class='stable_summary'></p>Get a
      specific customer
  - name: Warehouses
    description: >-
      <p data-section-id='tag/Warehouses' class='stable_summary'></p>Queries all
      storage locations for a given warehouse.
  - name: Units
    description: Development
  - name: Transaction Status
    description: >-
      <p data-section-id='tag/Transaction Status'
      class='stable_summary'></p>Queries all transaction statuses for a sales
      order.
  - name: Tax
    description: >-
      <p data-section-id='tag/Tax' class='stable_summary'></p>Returns the tax
      rate for the given item.
  - name: Inventory
    description: >-
      <p data-section-id='tag/Inventory' class='stable_summary'></p>Queries
      stocks for a specific item, warehouse or storage location.
  - name: Sales Order
    description: Planned
  - name: Sales Invoice Correction
    description: Planned
  - name: Sales Channel
    description: >-
      <p data-section-id='tag/Sales Channel' class='stable_summary'></p>Gets all
      sales channels.
  - name: Return
    description: >-
      <p data-section-id='tag/Return' class='beta_summary'></p>Create a new
      return with associated items and packages.
  - name: Item
    description: >-
      <p data-section-id='tag/Item' class='beta_summary'></p>Queries all
      responsible persons.
  - name: Refund
    description: Planned
  - name: Property
    description: >-
      <p data-section-id='tag/Property' class='stable_summary'></p>Queries all
      properties of items.
  - name: Printer
    description: >-
      <p data-section-id='tag/Printer' class='beta_summary'></p>Retrieves all
      installed printers.
  - name: Master Data
    description: >-
      <p data-section-id='tag/Master Data' class='stable_summary'></p>Queries
      all on hold reasons for sales orders.
  - name: Manufacturer
    description: Development
  - name: Label
    description: Development
  - name: Sales Invoice
    description: Planned
  - name: Info
    description: >-
      <p data-section-id='tag/Info' class='stable_summary'></p>Returns the
      status of the API.
  - name: Features
    description: >-
      <p data-section-id='tag/Features' class='stable_summary'></p>Returns the
      available feature sets with release state and API version.
  - name: Extensibility
    description: Planned
  - name: Shipment
    description: Development
  - name: Delivery Note
    description: Planned
  - name: Custom Field
    description: Development
  - name: Customer
    description: >-
      <p data-section-id='tag/Customer' class='stable_summary'></p>Deletes a
      specific customer.
  - name: Authentication
    description: >-
      <p data-section-id='tag/Authentication' class='stable_summary'></p>Send a
      registration request for an (external) application
  - name: Attribute
    description: Development
  - name: Sales Quotation
    description: >-
      <p data-section-id='tag/Sales Quotation' class='beta_summary'></p>Execute
      the printing of a sales quotation
  - name: Production
  - name: Resources
  - name: Company
  - name: Marketplace Order
  - name: Marketplace Offer
  - name: Marketplace Invoicing
  - name: Warehouse Assistant
paths:
  /v2/bills-of-materials/{billOfMaterialsId}/bill-of-materials-operations:
    post:
      tags:
        - Production
      summary: >-
        Creates a new bill of materials operation for a bill of materials,
        including its items.
      description: >-
        Creates a new bill of materials operation for a bill of materials,
        including its items.
      operationId: Create_CreateBillOfMaterialsOperation
      parameters:
        - name: billOfMaterialsId
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/JTL.Pps.Core.Contracts.Keys.BillOfMaterialKey'
            example: b45f6432-2462-4c6f-b00f-1d9d01000000
          x-position: 2
        - name: x-companyid
          in: header
          description: >-
            The Company-Id (int or uuid) of the company on whose behalf the
            request is executed.
          schema:
            type: string
        - name: x-tenant-id
          in: header
          required: true
          schema:
            type: string
            format: uuid
          description: The tenant ID for the target ERP instance.
      requestBody:
        x-name: request
        description: Request parameters
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateBillOfMaterialsOperationCommandRequest
        required: true
        x-position: 1
      responses:
        '201':
          description: Successfully created a bill of materials operation.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateBillOfMaterialsOperationCommandResponse
        '400':
          description: ''
          content:
            application/json: {}
        '401':
          description: ''
          content:
            application/json: {}
        '403':
          description: ''
          content:
            application/json: {}
        '404':
          description: ''
          content:
            application/json: {}
        '500':
          description: ''
          content:
            application/json: {}
      security:
        - oauth2-authorization-code:
            - pps.write
        - oauth2-client-credentials:
            - pps.write
components:
  schemas:
    JTL.Pps.Core.Contracts.Keys.BillOfMaterialKey:
      type: string
      format: uuid
      example: b45f6432-2462-4c6f-b00f-1d9d01000000
      additionalProperties: false
    JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateBillOfMaterialsOperationCommandRequest:
      type: object
      description: >-
        Creates a new bill of materials operation for a bill of materials,
        including its items. - Request
      additionalProperties: false
      required:
        - productionItemId
        - input
      properties:
        productionItemId:
          $ref: '#/components/schemas/JTL.Pps.Core.Contracts.Keys.ProdItemKey'
          description: The ID of the production item.
        input:
          $ref: >-
            #/components/schemas/JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateBillOfMaterialsOperationInput
          description: The input for creating a bill of materials operation.
    JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateBillOfMaterialsOperationCommandResponse:
      type: object
      description: >-
        Creates a new bill of materials operation for a bill of materials,
        including its items. - Response
      additionalProperties: false
      required:
        - id
      properties:
        id:
          $ref: >-
            #/components/schemas/JTL.Pps.Core.Contracts.Keys.BillOfMaterialComponentKey
          description: The ID of the newly created bill of materials operation.
    JTL.Pps.Core.Contracts.Keys.ProdItemKey:
      type: string
      description: Der Schlüssel eines Produktionsartikels.
      format: uuid
      example: b45f6432-2462-4c6f-b00f-1d9d01000000
      additionalProperties: false
    JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateBillOfMaterialsOperationInput:
      type: object
      description: >-
        Represents the input for creating a bill of materials operation as part
        of a new bill of materials.
      additionalProperties: false
      required:
        - operationId
      properties:
        operationId:
          $ref: '#/components/schemas/JTL.Pps.Core.Contracts.Keys.OperationKey'
          description: >-
            The ID of the operation to be assigned to this bill of materials
            operation. The operation must exist.
        items:
          type: array
          description: >-
            The bill of materials items assigned to this operation. Optional per
            individual operation, but at least one component must be present
            across all operations within the bill of materials.
          items:
            $ref: >-
              #/components/schemas/JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateBillOfMaterialsItemInput
    JTL.Pps.Core.Contracts.Keys.BillOfMaterialComponentKey:
      type: string
      format: uuid
      example: b45f6432-2462-4c6f-b00f-1d9d01000000
      additionalProperties: false
    JTL.Pps.Core.Contracts.Keys.OperationKey:
      type: string
      format: uuid
      example: b45f6432-2462-4c6f-b00f-1d9d01000000
      additionalProperties: false
    JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateBillOfMaterialsItemInput:
      type: object
      description: >-
        Represents the input for creating a bill of materials item as part of a
        bill of materials operation.
      additionalProperties: false
      required:
        - itemId
        - quantity
      properties:
        itemId:
          $ref: '#/components/schemas/JTL.Data.Contracts.Keys.ArtikelKey'
          description: The ID of the item to be used as a bill of materials item.
        quantity:
          type: number
          description: >-
            The required quantity of this component for the production of the
            production item. Must be greater than zero.
          format: decimal
        measurementUnitId:
          $ref: '#/components/schemas/JTL.Data.Contracts.Keys.MassEinheitKey'
          description: >-
            The ID of the measurement unit in which the quantity is managed, or
            NULL to use the sales unit of the underlying item.
        componentPostingsShelfLifeEndDateRequirements:
          $ref: >-
            #/components/schemas/JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateComponentPostingsInventoryAccountingDataRequirements
          description: >-
            Requirements for the production input of this component regarding
            the shelf life end dates of the stock accounts to be debited.
            Overrides the corresponding setting on the bill of materials level
            for this component. Optional; defaults to Inherited, which applies
            the requirement specified at the bill of materials level. Must not
            be set to a value other than Inherited if the underlying item does
            not have a shelf life end date configured.
        componentPostingsBatchNumberRequirements:
          $ref: >-
            #/components/schemas/JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateComponentPostingsInventoryAccountingDataRequirements
          description: >-
            Requirements for the production input of this component regarding
            the batch numbers of the stock accounts to be debited. Overrides the
            corresponding setting on the bill of materials level for this
            component. Optional; defaults to Inherited, which applies the
            requirement specified at the bill of materials level. Must not be
            set to a value other than Inherited if the underlying item does not
            have a batch number configured.
    JTL.Data.Contracts.Keys.ArtikelKey:
      type: string
      format: uuid
      example: b45f6432-2462-4c6f-b00f-1d9d01000000
      additionalProperties: false
    JTL.Data.Contracts.Keys.MassEinheitKey:
      type: string
      format: uuid
      example: b45f6432-2462-4c6f-b00f-1d9d01000000
      additionalProperties: false
    JTL.PPS.ProductionItems.PublicApi.DataTransferObjects.V2.Create.CreateComponentPostingsInventoryAccountingDataRequirements:
      type: integer
      description: 0 = Inherited, 1 = None, 2 = Identical
      format: int32
      x-enumNames:
        - Inherited
        - None
        - Identical
      enum:
        - 0
        - 1
        - 2
  securitySchemes:
    oauth2-authorization-code:
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: https://auth.jtl-cloud.com/oauth2/auth
          tokenUrl: https://auth.jtl-cloud.com/oauth2/token
          scopes:
            items.read: Grants permission to read item data.
            items.write: Grants permission to create and modify item data.
            all.read: Allows the application to read all data.
            authentication.updateforeignapp: Grants permission to update registered third-party apps.
            customers.read: Grants permission to read customer data.
            customers.write: Grants permission to create and modify customer data.
            customfields.read: Grants permission to read custom fields.
            customfields.write: Grants permission to create and modify custom fields.
            deliveries.read: Grants permission to read deliveries.
            deliveries.write: Grants permission to create and modify deliveries.
            deliverynotes.print: Grants permission to print and output delivery notes.
            deliverynotes.read: Grants permission to read delivery notes.
            deliverynotes.write: Grants permission to create and modify delivery notes.
            extensibility.integration: >-
              Grants permission to manage extensions and integrations of the
              JTL-Wawi.
            foreignapps.manage: >-
              Grants permission to manage registered third-party apps
              (registration, update and removal).
            inventories.read: Grants permission to read stock levels.
            inventories.write: Grants permission to modify stock levels.
            invoices.read: Grants permission to read invoices.
            invoices.write: Grants permission to create and modify invoices.
            labels.read: Grants permission to read labels.
            labels.write: Grants permission to create and modify labels.
            masterdata.read: >-
              Read master data such as shipping methods, payment methods, color
              codes and tax classes.
            orders.read: Grants permission to read orders.
            picklists.read: Grants permission to read pick lists.
            picklists.write: Grants permission to create and modify pick lists.
            returns.read: Grants permission to read returns.
            returns.write: Grants permission to create and modify returns.
            saleschannels.read: Grants permission to read sales channels.
            salesinvoicecorrections.read: Grants permission to read invoice corrections.
            salesinvoicecorrections.write: Grants permission to create and modify invoice corrections.
            salesorders.print: Grants permission to print and output sales orders.
            salesorders.read: Grants permission to read sales orders.
            salesorders.write: Grants permission to create and modify sales orders.
            system.config.read: Grants permission to read the system configuration.
            system.config.write: Grants permission to modify the system configuration.
            system.worker.read: >-
              Grants permission to read the configuration and status of
              background workers.
            system.worker.write: Grants permission to configure and control background workers.
            taxes.read: Grants permission to read tax data.
            warehouse.read: Grants permission to read warehouse data.
            wawiapp.all: Grants access to Wawi app related operations.
            currencies.read: Grants read access to currencies.
            jera.read: Grants read access to JERA internal endpoints.
            paymentmethods.read: Grants read access to payment methods.
            salesinvoicecorrections.print: Grants permission to print and output invoice corrections.
            salesinvoices.print: Grants permission to print and output sales invoices.
            salesinvoices.read: Grants read access to sales invoices.
            salesinvoices.write: Grants write access to sales invoices.
            salesquotations.print: Grants permission to print and output sales quotations.
            salesquotations.read: Grants read access to sales quotations.
            salesquotations.write: Grants write access to sales quotations.
            suppliers.read: Grants permission to read suppliers.
            resources.read: Grants permission to read resource management data.
            resources.write: Grants permission to create and modify resource management data.
            pps.read: Grants permission to read production data.
            pps.write: Grants permission to create and modify production data.
            masterdata.write: Write master data
            inventory.read: Grants permission to read stock levels.
            inventory.write: Grants permission to modify stock levels.
            taxes.write: Grants permission to create and modify tax data.
            application.runas: >-
              Allows the application to execute requests on behalf of another
              user.
    oauth2-client-credentials:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: https://auth.jtl-cloud.com/oauth2/token
          scopes:
            items.read: Grants permission to read item data.
            items.write: Grants permission to create and modify item data.
            all.read: Allows the application to read all data.
            authentication.updateforeignapp: Grants permission to update registered third-party apps.
            customers.read: Grants permission to read customer data.
            customers.write: Grants permission to create and modify customer data.
            customfields.read: Grants permission to read custom fields.
            customfields.write: Grants permission to create and modify custom fields.
            deliveries.read: Grants permission to read deliveries.
            deliveries.write: Grants permission to create and modify deliveries.
            deliverynotes.print: Grants permission to print and output delivery notes.
            deliverynotes.read: Grants permission to read delivery notes.
            deliverynotes.write: Grants permission to create and modify delivery notes.
            extensibility.integration: >-
              Grants permission to manage extensions and integrations of the
              JTL-Wawi.
            foreignapps.manage: >-
              Grants permission to manage registered third-party apps
              (registration, update and removal).
            inventories.read: Grants permission to read stock levels.
            inventories.write: Grants permission to modify stock levels.
            invoices.read: Grants permission to read invoices.
            invoices.write: Grants permission to create and modify invoices.
            labels.read: Grants permission to read labels.
            labels.write: Grants permission to create and modify labels.
            masterdata.read: >-
              Read master data such as shipping methods, payment methods, color
              codes and tax classes.
            orders.read: Grants permission to read orders.
            picklists.read: Grants permission to read pick lists.
            picklists.write: Grants permission to create and modify pick lists.
            returns.read: Grants permission to read returns.
            returns.write: Grants permission to create and modify returns.
            saleschannels.read: Grants permission to read sales channels.
            salesinvoicecorrections.read: Grants permission to read invoice corrections.
            salesinvoicecorrections.write: Grants permission to create and modify invoice corrections.
            salesorders.print: Grants permission to print and output sales orders.
            salesorders.read: Grants permission to read sales orders.
            salesorders.write: Grants permission to create and modify sales orders.
            system.config.read: Grants permission to read the system configuration.
            system.config.write: Grants permission to modify the system configuration.
            system.worker.read: >-
              Grants permission to read the configuration and status of
              background workers.
            system.worker.write: Grants permission to configure and control background workers.
            taxes.read: Grants permission to read tax data.
            warehouse.read: Grants permission to read warehouse data.
            wawiapp.all: Grants access to Wawi app related operations.
            currencies.read: Grants read access to currencies.
            jera.read: Grants read access to JERA internal endpoints.
            paymentmethods.read: Grants read access to payment methods.
            salesinvoicecorrections.print: Grants permission to print and output invoice corrections.
            salesinvoices.print: Grants permission to print and output sales invoices.
            salesinvoices.read: Grants read access to sales invoices.
            salesinvoices.write: Grants write access to sales invoices.
            salesquotations.print: Grants permission to print and output sales quotations.
            salesquotations.read: Grants read access to sales quotations.
            salesquotations.write: Grants write access to sales quotations.
            suppliers.read: Grants permission to read suppliers.
            resources.read: Grants permission to read resource management data.
            resources.write: Grants permission to create and modify resource management data.
            pps.read: Grants permission to read production data.
            pps.write: Grants permission to create and modify production data.
            masterdata.write: Write master data
            inventory.read: Grants permission to read stock levels.
            inventory.write: Grants permission to modify stock levels.
            taxes.write: Grants permission to create and modify tax data.
            application.runas: >-
              Allows the application to execute requests on behalf of another
              user.

````